/* Internal: lagnauge parsers use this file to create the bytecode.
   Host applications won't need any of these */

FAWK_API void fawkc_addi(fawk_ctx_t *ctx, fawk_ins_t ins);
FAWK_API void fawkc_addnum(fawk_ctx_t *ctx, fawk_num_t num);
FAWK_API void fawkc_addcs(fawk_ctx_t *ctx, const char *s);
FAWK_API void fawkc_adds(fawk_ctx_t *ctx, const char *s);
FAWK_API int fawkc_addsymref(fawk_ctx_t *ctx, const char *name, int isarr, int stack_from);

#include <libfawk/execute.h>

#define PUSH_IP() fawk_push_num(ctx, ctx->code.used)
#define CURR_IP() ctx->code.used

static void lazy_binop1(fawk_ctx_t *ctx, int is_or) { fawkc_addi(ctx, is_or ? FAWKI_POPJNZ : FAWKI_POPJZ); PUSH_IP(); fawkc_addnum(ctx, 777); }

static void lazy_binop2(fawk_ctx_t *ctx, int is_or)
{
	size_t jmp1 = fawk_pop_num(ctx, 1);

	/* if second operand is true (and:false), jump to emit true (and:false) */
	fawkc_addi(ctx, is_or ? FAWKI_POPJNZ : FAWKI_POPJZ);
	fawkc_addnum(ctx, CURR_IP()+5);

	/* push false and skip true (and: false) */
	fawkc_addi(ctx, FAWKI_PUSH_NUM);
	fawkc_addnum(ctx, is_or ? 0 : 1);
	fawkc_addi(ctx, FAWKI_JMP);
	fawkc_addnum(ctx, CURR_IP()+3);

	/* emit true (and: false) */
	ctx->code.code[jmp1].data.num = CURR_IP();
	fawkc_addi(ctx, FAWKI_PUSH_NUM);
	fawkc_addnum(ctx, is_or ? 1 : 0);
}

