#!/bin/sh

trunk=../..
tutbase=$trunk/doc/tutorial_
fawk=$trunk/fawk/fawk


run_tests()
{
	local lang="$1" tut r i o d broken diff res

	tut="${tutbase}${lang}"
	for r in *.ref
	do
		i=${r%%.ref}
		if test ! -f "$tut/$i.$lang"
		then
			continue
		fi
		o=${r%%.ref}.$lang.out
		d=${r%%.ref}.$lang.diff
		"$fawk" "-W$lang" "$tut/$i.$lang" > $o
		res=$?
		diff=`diff -u $r $o`
		if test $res -ne 0 -o ! -z "$diff"
		then
			echo "$diff" > "$d"
			broken="$broken $i"
		else
			rm $o $d 2>/dev/null
		fi
	done
	if test ! -z "$broken"
	then
		echo "$lang: $broken"
		return 1
	fi
	return 0
}

acc=0

for lang in fawk fbas fpas
do
	run_tests $lang
	res=$?
	acc=$(($acc+$res))
done

exit $acc


